# Aliens on My Lawn
# Copyright (C) 2009 Jeffrey Armstrong (a.k.a. PrintStar)
# http://jeff.rainbow-100.com/
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
# 
# A full version of the license terms is available in LICENSE.

from bullets import *

class Weapon:
    def __init__(self,name='Shotgun',damage=1,ammo=50):
        self.name=name
        self.damage=damage
        self.ammo=ammo
        self.base_ammo = ammo
    
    def reset(self):
        self.ammo = self.base_ammo
    
    def fire(self):
        if(self.ammo > 0):
            self.ammo = self.ammo - 1
            return self.bullet()
        else:
            return None
        
    def add(self,ammo):
        self.ammo = self.ammo + ammo
        
class Shotgun(Weapon):
    def __init__(self,ammo=50):
        Weapon.__init__(self,name='Shotgun',damage=1,ammo=ammo)
        
    def bullet(self):
        return ShotgunShell()